using System;
using System.Reflection;
using System.Data;
using System.Data.Common;
using System.Data.OleDb;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.IO;
using System.Drawing;

[assembly: AssemblyTitle("")]
[assembly: AssemblyDescription("")]
[assembly: AssemblyConfiguration("")]
[assembly: AssemblyCompany("")]
[assembly: AssemblyProduct("")]
[assembly: AssemblyCopyright("")]
[assembly: AssemblyTrademark("")]
[assembly: AssemblyCulture("")]
[assembly: AssemblyVersion("1.0.0.0")]
[assembly: AssemblyKeyFile("")]

namespace wwwSharp.ClrHost.Examples
{
	public class DataAccess: MarshalByRefObject
	{
		const int maxStringLength = 255;
	
		private string m_ConnectionString = "";
		private string m_SqlQuery = "";
		
		public string ConnectionString
		{
			get {return m_ConnectionString;}
			set {m_ConnectionString = value;}
		}
		
		public string SqlQuery
		{
			get {return m_SqlQuery;}
			set {m_SqlQuery = value;}
		}
		
		public string ConvertQueryToHtml()
		{
			string result = "";
			OleDbConnection conn = new OleDbConnection(m_ConnectionString);
			try
			{
			    System.Windows.Forms.Cursor.Current = System.Windows.Forms.Cursors.WaitCursor;
			
				conn.Open();
				OleDbCommand cmd = new OleDbCommand(m_SqlQuery, conn);
				OleDbDataAdapter adapter = new OleDbDataAdapter(cmd);
				result = WriteHtml(adapter);
			}
			finally
			{
				conn.Close();
				System.Windows.Forms.Cursor.Current = System.Windows.Forms.Cursors.Default;
			}
			
			return result;
		}
		
		public string GetTableNamesForSelect(string onchange)
		{
			string result = "";
			OleDbConnection conn = new OleDbConnection(m_ConnectionString);
			try
			{
			    System.Windows.Forms.Cursor.Current = System.Windows.Forms.Cursors.WaitCursor;
			
				conn.Open();
				DataTable tables = conn.GetOleDbSchemaTable(OleDbSchemaGuid.Tables,
					new object[] {null, null, null, "TABLE"});
				result = WriteTables(tables, onchange);
			}
			finally
			{
				conn.Close();
				System.Windows.Forms.Cursor.Current = System.Windows.Forms.Cursors.Default;
			}
			
			return result;
		}
		
		private string WriteHtml(DbDataAdapter adapter)
		{
			DataTable table = new DataTable();
			adapter.MissingSchemaAction = MissingSchemaAction.AddWithKey;
			adapter.Fill(table);
			
			StringWriter strWriter = new StringWriter();
			HtmlTextWriter htmlWriter = new HtmlTextWriter(strWriter);

			DataGrid grid = new DataGrid();
			grid.ID = "tblQuery";

			grid.BackColor = Color.FromArgb(0xccccff0);
			grid.BorderColor = Color.Black;
			grid.ShowFooter = false;
			grid.CellPadding = 3;
			grid.CellSpacing = 0;
			grid.Font.Name = "Verdana";
			grid.Font.Size = new FontUnit("8pt");
			grid.HeaderStyle.BackColor = Color.FromArgb(0xaaaadd0);
			grid.EnableViewState = false;
			grid.Width = new Unit(CalculateTableWidth(table).ToString() + "ex");

			grid.DataSource = table;
			grid.DataBind();

			grid.RenderControl(htmlWriter);
			return strWriter.ToString();
		}
		
		protected int CalculateTableWidth(DataTable table)
		{
		    int result = 0;
		    foreach (DataColumn col in table.Columns)
		    {
		        int colWidth = 10;
		        
				if (col.DataType == typeof(string))
				{
					colWidth = col.MaxLength;
					if (colWidth < 6) colWidth = 10;
					if (colWidth > 50) colWidth = 50;
				}
				else if (col.DataType == typeof(DateTime))
				{
					colWidth = 20;
				}

				result += colWidth;
		    }
		    
		    return result + 5;
		}
		
		protected static string WriteTables(DataTable schema, string onchange)
		{
			StringWriter strWriter = new StringWriter();
			HtmlTextWriter htmlWriter = new HtmlTextWriter(strWriter);
			
			DataView sortedSchema = new DataView(schema,
				"TABLE_TYPE = 'TABLE' OR TABLE_TYPE = 'VIEW'",
				"TABLE_NAME", DataViewRowState.CurrentRows);
			
   			ListBox listBox = new ListBox();
			listBox.ID = "selectTables";
			listBox.DataSource = schema;
			listBox.DataTextField = "TABLE_NAME";
			listBox.DataValueField = "TABLE_NAME";
			listBox.Rows = 1;
			listBox.Attributes["onchange"] = onchange;
			listBox.DataBind();
			listBox.RenderControl(htmlWriter);
			
			return strWriter.ToString();
		}
	}
}
